# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/leds/leds-lp5860.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: LED driver for LP5860 RGB LED from Texas Instruments.

maintainers:
  - Steffen Trumtrar <kernel@pengutronix.de>

description: |
  The LP5860 is multi-channel, I2C and SPI RGB LED Driver that can group RGB LEDs
  into a LED group or control them individually.

  For more product information please see the link below:
  https://www.ti.com/lit/ds/symlink/lp5860.pdf

allOf:
  - $ref: /schemas/spi/spi-peripheral-props.yaml#

properties:
  compatible:
    enum:
      - ti,lp5860

  reg:
    maxItems: 1

  '#address-cells':
    const: 1

  '#size-cells':
    const: 0

patternProperties:
  '^multi-led@[0-9a-f]+$':
    type: object
    $ref: leds-class-multicolor.yaml#
    unevaluatedProperties: false

    properties:
      reg:
        minimum: 0
        maximum: 198
        description:
          This property denotes the LED module number that is used
          for the child node.

      '#address-cells':
        const: 1

      '#size-cells':
        const: 0

    patternProperties:
      "^led@[0-9a-f]+$":
        type: object
        $ref: common.yaml#
        unevaluatedProperties: false

        properties:
          reg:
            maxItems: 1

        required:
          - reg

required:
  - compatible
  - reg

unevaluatedProperties: false

examples:
  - |
    #include <dt-bindings/leds/common.h>

    spi {
        #address-cells = <1>;
        #size-cells = <0>;

        led-controller@0 {
            compatible = "ti,lp5860";
            reg = <0x0>;
            #address-cells = <1>;
            #size-cells = <0>;

            multi-led@0 {
                #address-cells = <1>;
                #size-cells = <0>;
                reg = <0x0>;
                color = <LED_COLOR_ID_RGB>;

                led@0 {
                     reg = <0x0>;
                     color = <LED_COLOR_ID_RED>;
                };

                led@1 {
                     reg = <0x1>;
                     color = <LED_COLOR_ID_GREEN>;
                };

                led@2 {
                     reg = <0x2>;
                     color = <LED_COLOR_ID_BLUE>;
                };
            };
        };
    };
